const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const import_issues = sequelize.define(
    'import_issues',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

severity: {
        type: DataTypes.ENUM,
      
      

        values: [

"error",


"warning"

        ],

      },

field_name: {
        type: DataTypes.TEXT,
      
      

      },

message: {
        type: DataTypes.TEXT,
      
      

      },

details: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  import_issues.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
























//end loop



    db.import_issues.belongsTo(db.import_row_results, {
      as: 'row_result',
      foreignKey: {
        name: 'row_resultId',
      },
      constraints: false,
    });

    db.import_issues.belongsTo(db.validation_rules, {
      as: 'rule',
      foreignKey: {
        name: 'ruleId',
      },
      constraints: false,
    });

    db.import_issues.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.import_issues.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.import_issues.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return import_issues;
};


